<?php
namespace Teknisa\Entities;

use Setforms2\Shared\Registry;

class SitLogprod extends Base\SitLogprod
{

    /**
     * Insere produto na remessa.
     *
     * @param String $nrremessa  Nrremessa
     * @param String $cdproduto  Cdproduto
     * @param String $nrorg      Nrorg
     * @param String $dataAtual  DataAtual
     * @param String $cdoperador CdOperador
     *
     * @return null
     * @throws \Exception
     */
    public static function insereProduto (
        $nrremessa, $cdproduto, $observacao, $nrorg, $dataAtual, $cdoperador
    ) {
        $sitlogprod = new self();
        $sitlogprod->setNrremessa($nrremessa);
        $sitlogprod->setCdproduto($cdproduto);
        $sitlogprod->setDsobservacao($observacao);
        $sitlogprod->setDtenvio($dataAtual);
        $sitlogprod->setNrorg($nrorg);
        $sitlogprod->setNrorginclusao($nrorg);
        $sitlogprod->setNrorgultatu($nrorg);
        $sitlogprod->setDtinclusao($dataAtual);
        $sitlogprod->setDtultatu($dataAtual);
        $sitlogprod->setCdoperinclusao($cdoperador);
        $sitlogprod->setCdoperultatu($cdoperador);
        $sitlogprod->persist();
    }

    /**
     * Atualiza a tabela SIT_LOGPROD
     *
     * @param String $nrremessa    Remessa
     * @param String $cdproduto    Produto
     * @param String $nrremessaret Remessa de Retorno
     * @param String $dataAtual    Data Atual
     * @param String $idativo      Ativo
     *
     * @return null
     */
    public static function atualizaRetorno (
        $nrremessa, $cdproduto, $nrremessaret, $dataAtual, $idativo
    ) {
        $reg = self::getObjectByWhere(
            "NRREMESSA = ? AND CDPRODUTO = ?",
            array($nrremessa, $cdproduto)
        );

        if ($reg instanceof self) {
            $reg->setNrremessaret($nrremessaret);
            $reg->setDtretorno($dataAtual);

            if ($idativo == 'N') {
                $reg->setDsobservacao(
                    tk_get_message_by_name('msg_ger07600_naoSeAplica')
                );
            }

            $reg->persist();
        }
    }

}