/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SEGMERCADO                                               */
/* Tabela : SEGMERCADO                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 13/03/2002 - Alexis Tolentino de Moura                                     */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SEGMERCADO
BEFORE INSERT OR UPDATE OR DELETE
ON SEGMERCADO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSEGM := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSEGMER,0) <> NVL(:NEW.CDSEGMER,0)) OR
           (NVL(:OLD.DSSEGMER,0) <> NVL(:NEW.DSSEGMER,0)) OR
           (NVL(:OLD.CDPRECOPROP,0) <> NVL(:NEW.CDPRECOPROP,0)) THEN
         :NEW.DTULTATUSEGM := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SEGMERCADO', '', 'CDSEGMER='||:OLD.CDSEGMER||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SEGMERCADO MODIFY DTULTATUSEGM DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_SEGMERCADO','5.05.011'); END;
/

