CREATE OR REPLACE
PROCEDURE EXPORTA_CARDAPIO_INCOR 
   (P_CDFILIORIG  IN FILIAL.CDFILIAL%TYPE,
    P_CDSERVORIG  IN VARCHAR2,
    P_DTINIORIG   IN CARDADIA.DTCARDAPIO%TYPE,
    P_DTFINORIG   IN CARDADIA.DTCARDAPIO%TYPE,
    P_CDFILIDEST  IN FILIAL.CDFILIAL%TYPE,
    P_CDSERVDEST  IN VARCHAR2,
    P_DTINIDEST   IN CARDADIA.DTCARDAPIO%TYPE,
    P_DTFINDEST   IN CARDADIA.DTCARDAPIO%TYPE,
    P_CONFIGORIG  IN VARCHAR2,
    P_IDCOPCOMENS IN VARCHAR2,
    P_IDSOBREPOR  IN VARCHAR2,
    P_CDOPERADOR  IN OPERADOR.CDOPERADOR%TYPE,
    P_MODOPROC    IN VARCHAR2,
    P_NRLOGINTCARD OUT LOGINTCARD.NRLOGINTCARD%TYPE) IS

    V_COUNT          NUMBER;
    V_LCONFIGORIG    VARCHAR(2000);
    V_CONFIGORIG     VARCHAR(10);
    V_LCDSERVDEST    VARCHAR(2000);
    V_CDSERVDEST     VARCHAR(5);
    V_LCDSERVORIG    VARCHAR(2000);
    V_CDSERVORIG     VARCHAR(5);
    V_DTMESORIG      DATE;
    V_DTMESDEST      DATE;
    V_DTCARDDEST     DATE;
    V_CONTCARDDEST   NUMBER;
    V_NRCARDAPIO     VARCHAR2(20);
    V_CONTPRAT       NUMBER;
    V_CDFILAUXDEST   VARCHAR2(4);
    V_IDCARDIAUTIL   VARCHAR2(1);
    V_MAXNRSEQDEST   NUMBER;
    V_MAXNRORDDEST   NUMBER;
    V_DIASEMANA      NUMBER;
    V_CONTFERIFILI   NUMBER;
    V_CONTPRODRECE   NUMBER;
    V_IDUTRPADCA     VARCHAR2(1);
    V_IDTIPOSERV     VARCHAR2(1);
    V_IDCARDDESCENTR VARCHAR2(1);
    V_CDDIETDEST     VARCHAR2(4);
    V_NRLOGINTCARD   VARCHAR2(20);
    V_EXISTPRAT      NUMBER;
    V_NOVOSEQ        NUMBER;
    V_NOVOORD        NUMBER;
    V_VALOR_A_MAIS   NUMBER;        
    V_TIPOCARDAPIO   VARCHAR2(1); 
    V_TIPORECE       VARCHAR2(1);
    V_CDNVPRODUTO    VARCHAR2(1);
    V_PRODINATIVO    BOOLEAN := FALSE;
    V_CDARVPRODINAT  VARCHAR2(20);    
    V_DTMESCARD      DATE;
    V_UPDATA         VARCHAR2(1);
    V_CONFIGCARDVAZIO VARCHAR2(1);
    /* Variveis para cursores */

    C_DATAS_DTORIGEM   DATE;
    C_COMENSSERV_QTCOM FLOAT(126);
    C_COMENSSERV_QTCLI FLOAT(126);
    C_COMENSSERV_QTFUN FLOAT(126);
    C_COMENSSERV_QTDOA FLOAT(126);
    C_TURNOSERV_QTT1   FLOAT(126);
    C_TURNOSERV_QTT2   FLOAT(126);
    C_TURNOSERV_QTT3   FLOAT(126);
    C_TURNOSERV_QTT4   FLOAT(126);

    /* Cursores */
    CURSOR C_DATAS IS
    SELECT DTDATA
    FROM   DATA
    WHERE  DTDATA BETWEEN P_DTINIORIG AND P_DTFINORIG;

    CURSOR C_COMENSSERV IS
    SELECT NVL(DECODE(V_DIASEMANA,2,QTCOMESTISEG,3,QTCOMESTITER,4,QTCOMESTIQUA,5,QTCOMESTIQUI,6,QTCOMESTISEX,7,QTCOMESTISAB,1,QTCOMESTIDOM,8,QTCOMESTIFER),0),
           NVL(DECODE(V_DIASEMANA,2,QTCLIESTISEG,3,QTCLIESTITER,4,QTCLIESTIQUA,5,QTCLIESTIQUI,6,QTCLIESTISEX,7,QTCLIESTISAB,1,QTCLIESTIDOM,8,QTCLIESTIFER),0),
           NVL(DECODE(V_DIASEMANA,2,QTFUNESTISEG,3,QTFUNESTITER,4,QTFUNESTIQUA,5,QTFUNESTIQUI,6,QTFUNESTISEX,7,QTFUNESTISAB,1,QTFUNESTIDOM,8,QTFUNESTIFER),0),
           NVL(DECODE(V_DIASEMANA,2,QTDOAESTISEG,3,QTDOAESTITER,4,QTDOAESTIQUA,5,QTDOAESTIQUI,6,QTDOAESTISEX,7,QTDOAESTISAB,1,QTDOAESTIDOM,8,QTDOAESTIFER),0)
    FROM   SERVICO
    WHERE  CDFILIAL = P_CDFILIDEST AND
           CDSERVFILI = V_CDSERVDEST;

    CURSOR C_TURNOSERV IS
    SELECT SUM(T1),SUM(T2),SUM(T3),SUM(T4)
    FROM   (SELECT NVL(DECODE(V_DIASEMANA,2,QTCOMESTTSEG,3,QTCOMESTTTER,4,QTCOMESTTQUA,5,QTCOMESTTQUI,6,QTCOMESTTSEX,7,QTCOMESTTSAB,1,QTCOMESTTDOM,8,QTCOMESTTFER), 0) T1,
                   0 T2, 0 T3, 0 T4
            FROM   TURNOSERV
            WHERE  CDFILIAL = P_CDFILIDEST AND
                   CDSERVFILI = V_CDSERVDEST AND
                   CDTURNO = '1'
            UNION
            SELECT 0 T1,
                   NVL(DECODE(V_DIASEMANA,2,QTCOMESTTSEG,3,QTCOMESTTTER,4,QTCOMESTTQUA,5,QTCOMESTTQUI,6,QTCOMESTTSEX,7,QTCOMESTTSAB,1,QTCOMESTTDOM,8,QTCOMESTTFER), 0) T2,
                   0 T3, 0 T4
            FROM   TURNOSERV
            WHERE  CDFILIAL = P_CDFILIDEST AND
                   CDSERVFILI = V_CDSERVDEST AND
                   CDTURNO = '2'
            UNION
            SELECT 0 T1, 0 T2,
                   NVL(DECODE(V_DIASEMANA,2,QTCOMESTTSEG,3,QTCOMESTTTER,4,QTCOMESTTQUA,5,QTCOMESTTQUI,6,QTCOMESTTSEX,7,QTCOMESTTSAB,1,QTCOMESTTDOM,8,QTCOMESTTFER), 0) T3,
                   0 T4
            FROM   TURNOSERV
            WHERE  CDFILIAL = P_CDFILIDEST AND
                   CDSERVFILI = V_CDSERVDEST AND
                   CDTURNO = '3'
            UNION
            SELECT 0 T1, 0 T2, 0 T3,
                   NVL(DECODE(V_DIASEMANA,2,QTCOMESTTSEG,3,QTCOMESTTTER,4,QTCOMESTTQUA,5,QTCOMESTTQUI,6,QTCOMESTTSEX,7,QTCOMESTTSAB,1,QTCOMESTTDOM,8,QTCOMESTTFER), 0) T4
            FROM   TURNOSERV
            WHERE  CDFILIAL = P_CDFILIDEST AND
                   CDSERVFILI = V_CDSERVDEST AND
                   CDTURNO = '4');

     CURSOR C_DIETSERV IS
     SELECT NVL(DECODE(V_DIASEMANA,2,QTCOMDIETSEG,3,QTCOMDIETTER,4,QTCOMDIETQUA,5,QTCOMDIETQUI,6,QTCOMDIETSEX,7,QTCOMDIETSAB,1,QTCOMDIETDOM,8,QTCOMDIETFER),0),
            NVL(DECODE(V_DIASEMANA,2,QTCLIDIETSEG,3,QTCLIDIETTER,4,QTCLIDIETQUA,5,QTCLIDIETQUI,6,QTCLIDIETSEX,7,QTCLIDIETSAB,1,QTCLIDIETDOM,8,QTCLIDIETFER),0),
            NVL(DECODE(V_DIASEMANA,2,QTFUNDIETSEG,3,QTFUNDIETTER,4,QTFUNDIETQUA,5,QTFUNDIETQUI,6,QTFUNDIETSEX,7,QTFUNDIETSAB,1,QTFUNDIETDOM,8,QTFUNDIETFER),0),
            NVL(DECODE(V_DIASEMANA,2,QTDOADIETSEG,3,QTDOADIETTER,4,QTDOADIETQUA,5,QTDOADIETQUI,6,QTDOADIETSEX,7,QTDOADIETSAB,1,QTDOADIETDOM,8,QTDOADIETFER),0)
     FROM   DIETSERV S, DIETPADR P
     WHERE  CDFILIAL     = P_CDFILIDEST AND
            CDSERVFILI   = V_CDSERVDEST AND
            S.CDDIETPAD  = V_CDDIETDEST AND
            P.CDDIETPAD  = S.CDDIETPAD  AND
            P.IDTIPODIET = 'S';

BEGIN
   V_LCDSERVDEST := P_CDSERVDEST;
   V_LCDSERVORIG := P_CDSERVORIG;
   V_LCONFIGORIG := P_CONFIGORIG;
   V_NRLOGINTCARD := NULL;   

   IF SUBSTR(V_LCDSERVORIG, 1, 1) = '_' THEN
      V_LCDSERVORIG := SUBSTR(V_LCDSERVORIG, 2, LENGTH(V_LCDSERVORIG));
   END IF;

   IF SUBSTR(V_LCDSERVDEST, 1, 1) = '_' THEN
      V_LCDSERVDEST := SUBSTR(V_LCDSERVDEST, 2, LENGTH(V_LCDSERVDEST));
   END IF;

   IF SUBSTR(V_LCONFIGORIG, 1, 1) = '_' THEN
      V_LCONFIGORIG := SUBSTR(V_LCONFIGORIG, 2, LENGTH(V_LCONFIGORIG));
   END IF;
   WHILE ( ( NOT V_LCDSERVDEST IS NULL ) AND ( NOT V_LCDSERVORIG IS NULL ) AND ( NOT V_LCONFIGORIG IS NULL ) )
   LOOP /* Loop para Exportar mais de um Servico */
   /* Atribui valores de lista nas devidas variveis */
      V_UPDATA := 'N';
      V_COUNT := 1;      
      V_DTMESCARD := NULL;
      
      LOOP
         EXIT WHEN SUBSTR(V_LCDSERVDEST, V_COUNT, 1)= '_';
         V_COUNT := V_COUNT + 1 ;
      END LOOP;

      V_CDSERVORIG := SUBSTR(V_LCDSERVORIG, 1, V_COUNT-1);

      V_COUNT := 1;
      LOOP
         EXIT WHEN SUBSTR(V_LCDSERVDEST, V_COUNT, 1)= '_';
         V_COUNT := V_COUNT + 1 ;
      END LOOP;

      V_CDSERVDEST := SUBSTR(V_LCDSERVDEST, 1, V_COUNT-1);

      V_COUNT := 1;
      LOOP
         EXIT WHEN SUBSTR(V_LCONFIGORIG, V_COUNT, 1)= '_';
         V_COUNT := V_COUNT + 1 ;
      END LOOP;

      V_CONFIGORIG := SUBSTR(V_LCONFIGORIG, 1, V_COUNT-1);
      /* Fim de atribuio de valores de lista */

      /* Grava o primeiro dia do ms de origem e destino */
      V_DTMESORIG := LAST_DAY(ADD_MONTHS(P_DTINIORIG,-1))+1;
      V_DTMESDEST := LAST_DAY(ADD_MONTHS(P_DTINIDEST,-1))+1;

      BEGIN
         SELECT IDUTCARDPADR
         INTO   V_TIPOCARDAPIO
         FROM   PARAMGERAL
         WHERE  CDPARGERAL = '0001';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_TIPOCARDAPIO := 'N';
      END;

      SELECT IDTIPOSERV
      INTO   V_IDTIPOSERV
      FROM   SERVICO
      WHERE  CDFILIAL   = P_CDFILIORIG AND
             CDSERVFILI = V_CDSERVORIG;

      SELECT NVL(IDCARDDESCENTR, 'N')
      INTO   V_IDCARDDESCENTR
      FROM   SERVICO
      WHERE  CDFILIAL   = P_CDFILIDEST AND
             CDSERVFILI = V_CDSERVDEST;        

      /* Opo sobrepor */
      IF P_IDSOBREPOR = 'S' THEN
         FOR C_CARDDEL IN
            (SELECT CDFILIAL, CDSERVFILI, DTCARDAPIO, NRCARDAPIO
             FROM   CARDADIA
             WHERE  CDFILIAL   = P_CDFILIDEST AND
                    CDSERVFILI = V_CDSERVDEST AND
                    DTCARDAPIO BETWEEN P_DTINIDEST AND P_DTFINDEST)
         LOOP
            DELETE FROM COMPCARD
            WHERE CDFILIAL = C_CARDDEL.CDFILIAL AND
                  NRCARDAPIO = C_CARDDEL.NRCARDAPIO;
                  
            DELETE FROM CARDADIA 
            WHERE CDFILIAL = C_CARDDEL.CDFILIAL AND
                  NRCARDAPIO = C_CARDDEL.NRCARDAPIO AND
                  CDSERVFILI = C_CARDDEL.CDSERVFILI AND
                  DTCARDAPIO = C_CARDDEL.DTCARDAPIO;                
            DELETE FROM CNFCAMES
             WHERE CDFILIAL = C_CARDDEL.CDFILIAL
               AND CDSERVFILI = C_CARDDEL.CDSERVFILI
               AND DTREFECNFMES = LAST_DAY(ADD_MONTHS(P_DTINIDEST,-1))+1;
         END LOOP;
      END IF;

      /* Opo ACRESCENTAR - os tipos de prato sero includos ao final da tabela de configurao */

      V_DTCARDDEST := P_DTINIDEST;      

      /* Verifica o parmetro que permite cardpio em dia no-til */
      SELECT NVL(MAX(IDCARDIAUTIL), 'N')
      INTO   V_IDCARDIAUTIL
      FROM   PARAMPLANEJA
      WHERE  CDFILIAL = P_CDFILIDEST;

      OPEN C_DATAS;
      LOOP
         FETCH C_DATAS INTO C_DATAS_DTORIGEM;
         EXIT WHEN C_DATAS%NOTFOUND;
         
         SELECT COUNT(*)
         INTO   V_CONTFERIFILI
         FROM   FERIFILI
         WHERE  CDFILIAL = P_CDFILIDEST AND
                DTFERIFILI = V_DTCARDDEST;
          /* Grava o nmero correspondente ao dia da semana */
         IF V_CONTFERIFILI = 0 THEN
            V_DIASEMANA := TO_CHAR(V_DTCARDDEST,'D');
         ELSE
            V_DIASEMANA := 8;
         END IF;
         /* Permite incluso quando: */
         /* V_IDCARDIAUTIL <> 'S' (NO BLOQUEIA INCLUSO EM DIA NO TIL) OR
            V_IDCARDIAUTIL = 'S' AND V_CONTFERIFILI = 0 (SE BLOQUEIA, O DIA  NORMAL) */
         
         IF (V_DTCARDDEST <= P_DTFINDEST) AND
            ((V_IDCARDIAUTIL <> 'S') OR ((V_IDCARDIAUTIL = 'S') AND (V_CONTFERIFILI = 0))) THEN          
            IF V_DTMESCARD <> (LAST_DAY(ADD_MONTHS(V_DTCARDDEST,-1))+1) OR  V_DTMESCARD IS NULL THEN
               /*VERIFICA SE O CARDAPIO DE DESTINO ESTA SEM CONFIGURAO*/    
               V_DTMESCARD := (LAST_DAY(ADD_MONTHS(V_DTCARDDEST,-1))+1);               
               BEGIN
                  SELECT DISTINCT 'N' 
                    INTO V_CONFIGCARDVAZIO
                    FROM CNFCAMES
                   WHERE CDFILIAL = P_CDFILIDEST
                     AND DTREFECNFMES = V_DTMESCARD
                     AND CDSERVFILI = V_CDSERVDEST;                    
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CONFIGCARDVAZIO := 'S';
               END;                  
               IF V_CONFIGCARDVAZIO = 'S' THEN                
                  /*SE ESTIVER SEM CONFIGURAO INSERE A CONFIGURAO DA ORIGEM*/                  
                  INSERT INTO CNFCAMES
                     (CDFILIAL, CDSERVFILI, NRSEQCNFMES, DTREFECNFMES,
                      CDTIPOPRAT, IDOPCCNFMES, IDIMPCNFMES, NRPAGCNFMES,
                      VRPERCOMMES, NRORDCNFMES, DSCOMPLTPMES, IDCONCNFMES,
                      IDTPPRATSEGM, IDTPPRATTERM, IDTPPRATQUAM, IDTPPRATQUIM,
                      IDTPPRATSEXM, IDTPPRATSABM, IDTPPRATDOMM, IDTPPRATFERM)
                  SELECT
                      CDFILIDEST, CDSERVDEST, NRSEQCNFMES, DTMESDEST,
                      CDTIPOPRAT, IDOPCCNFMES, IDIMPCNFMES, NRPAGCNFMES,
                      VRPERCOMMES, NRORDCNFMES, DSCOMPLTPMES, IDCONCNFMES,
                      IDTPPRATSEGM, IDTPPRATTERM, IDTPPRATQUAM, IDTPPRATQUIM,
                      IDTPPRATSEXM, IDTPPRATSABM, IDTPPRATDOMM, IDTPPRATFERM
                   FROM (SELECT P_CDFILIDEST CDFILIDEST, V_CDSERVDEST CDSERVDEST,
                                NRSEQCNFMES, V_DTMESCARD DTMESDEST,
                                CDTIPOPRAT, IDOPCCNFMES, IDIMPCNFMES, NVL(NRPAGCNFMES,1) NRPAGCNFMES,
                                NVL(VRPERCOMMES,0) VRPERCOMMES, NRORDCNFMES, DSCOMPLTPMES, IDCONCNFMES,
                                IDTPPRATSEGM, IDTPPRATTERM, IDTPPRATQUAM, IDTPPRATQUIM,
                                IDTPPRATSEXM, IDTPPRATSABM, IDTPPRATDOMM, IDTPPRATFERM
                           FROM CNFCAMES, LISTA
                          WHERE (CDFILIAL     = P_CDFILIORIG) 
                            AND (CDSERVFILI   = V_CDSERVORIG) 
                            AND (DTREFECNFMES = V_DTMESORIG )
                            AND (NRSEQCNFMES  = LISTA.CDLISTA)
                            AND (LISTA.NRLISTA = V_CONFIGORIG)
                          ORDER BY NRORDCNFMES);
               END IF;           
            END IF;
            FOR C_CARDORIG IN
              (SELECT CDFILIAL, CDSERVFILI, DTCARDAPIO, NRCARDAPIO,
                      CDDIETPAD, DTMESCARD, DSCARDAPIO,
                      QTCOMESTICAR, QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
                      QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4
               FROM   CARDADIA
               WHERE  CDFILIAL   = P_CDFILIORIG AND
                      CDSERVFILI = V_CDSERVORIG AND
                      DTCARDAPIO = C_DATAS_DTORIGEM
               ORDER BY CDFILIAL, CDSERVFILI, DTCARDAPIO, CDDIETPAD)
            LOOP
               IF V_IDTIPOSERV = 'N' THEN
                  SELECT COUNT(*)
                  INTO   V_CONTCARDDEST
                  FROM   CARDADIA
                  WHERE  CDFILIAL   = P_CDFILIDEST AND
                         CDSERVFILI = V_CDSERVDEST AND
                         DTCARDAPIO = V_DTCARDDEST;
               END IF;
               IF V_IDTIPOSERV = 'D' THEN
                  SELECT COUNT(*)
                  INTO   V_CONTCARDDEST
                  FROM   CARDADIA
                  WHERE  CDFILIAL   = P_CDFILIDEST AND
                         CDSERVFILI = V_CDSERVDEST AND
                         DTCARDAPIO = V_DTCARDDEST AND
                         CDDIETPAD  = C_CARDORIG.CDDIETPAD;
               END IF;
               V_CDDIETDEST := 'XXXX';

               /* Verifica se a dieta de origem est cadastrada no servio destino. */
               SELECT NVL(MAX(S.CDDIETPAD),'XXXX')
               INTO   V_CDDIETDEST
               FROM   DIETSERV S, DIETPADR P
               WHERE  CDFILIAL = P_CDFILIDEST AND
                      CDSERVFILI = V_CDSERVDEST AND
                      S.CDDIETPAD = C_CARDORIG.CDDIETPAD AND
                      P.CDDIETPAD = S.CDDIETPAD AND
                      P.IDTIPODIET = 'S';

               IF (V_IDTIPOSERV = 'N') OR (V_IDTIPOSERV = 'D' AND (V_CDDIETDEST <> 'XXXX')) THEN
               /* Gera novo nmero de cardpio se no existir */
                  IF V_CONTCARDDEST = 0 THEN
                     V_NRCARDAPIO := NULL;
                     NOVO_CODIGO('CARDAPIO'||P_CDFILIDEST, V_NRCARDAPIO, 1);
                     V_NRCARDAPIO := SUBSTR(V_NRCARDAPIO,11,10);

                     IF P_IDCOPCOMENS = 'S' THEN
                        /* Insere o novo cardpio copiando os comensais da origem */
                         C_COMENSSERV_QTCOM := C_CARDORIG.QTCOMESTICAR;
                         C_COMENSSERV_QTCLI := C_CARDORIG.QTCLIESTICAR;
                         C_COMENSSERV_QTFUN := C_CARDORIG.QTFUNESTICAR;
                         C_COMENSSERV_QTDOA := C_CARDORIG.QTDOAESTICAR;
                         C_TURNOSERV_QTT1   := C_CARDORIG.QTESTITURNO1;
                         C_TURNOSERV_QTT2   := C_CARDORIG.QTESTITURNO2;
                         C_TURNOSERV_QTT3   := C_CARDORIG.QTESTITURNO3;
                         C_TURNOSERV_QTT4   := C_CARDORIG.QTESTITURNO4;
                     ELSE
                     /* Insere o novo cardpio com os comensais do servio ou dieta destino */
                        IF V_IDTIPOSERV = 'N' THEN                           
                           OPEN C_COMENSSERV;
                           FETCH C_COMENSSERV INTO
                              C_COMENSSERV_QTCOM,
                              C_COMENSSERV_QTCLI,
                              C_COMENSSERV_QTFUN,
                              C_COMENSSERV_QTDOA;
                            IF C_COMENSSERV%NOTFOUND THEN
                               C_COMENSSERV_QTCOM := 0;
                               C_COMENSSERV_QTCLI := 0;
                               C_COMENSSERV_QTFUN := 0;
                               C_COMENSSERV_QTDOA := 0;
                            END IF;
                            CLOSE C_COMENSSERV;
                        END IF;
                        IF V_IDTIPOSERV = 'D' THEN
                            OPEN C_DIETSERV;
                            FETCH C_DIETSERV INTO
                               C_COMENSSERV_QTCOM,
                               C_COMENSSERV_QTCLI,
                               C_COMENSSERV_QTFUN,
                               C_COMENSSERV_QTDOA;
                            IF C_DIETSERV%NOTFOUND THEN
                               C_COMENSSERV_QTCOM := 0;
                               C_COMENSSERV_QTCLI := 0;
                               C_COMENSSERV_QTFUN := 0;
                               C_COMENSSERV_QTDOA := 0;
                            END IF;
                            CLOSE C_DIETSERV;
                        END IF;

                        OPEN C_TURNOSERV;
                        FETCH C_TURNOSERV INTO
                           C_TURNOSERV_QTT1,
                           C_TURNOSERV_QTT2,
                           C_TURNOSERV_QTT3,
                           C_TURNOSERV_QTT4;
                        IF C_TURNOSERV%NOTFOUND THEN
                           C_TURNOSERV_QTT1 := 0;
                           C_TURNOSERV_QTT2 := 0;
                           C_TURNOSERV_QTT3 := 0;
                           C_TURNOSERV_QTT4 := 0;
                        END IF;
                        CLOSE C_TURNOSERV;
                     END IF;

                     IF (C_COMENSSERV_QTCOM <> 0) AND (NOT C_COMENSSERV_QTCOM IS NULL) THEN
                        INSERT INTO CARDADIA
                          (CDFILIAL, CDSERVFILI, DTCARDAPIO, NRCARDAPIO,
                           CDDIETPAD, DTMESCARD, CDOPERADOR, DSCARDAPIO, DTULTATUACAR,
                           QTCOMESTICAR, QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
                           QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4, IDCARDIAESPE)
                        VALUES
                           (P_CDFILIDEST, V_CDSERVDEST, V_DTCARDDEST, V_NRCARDAPIO,
                            C_CARDORIG.CDDIETPAD, (LAST_DAY(ADD_MONTHS(V_DTCARDDEST,-1))+1), P_CDOPERADOR, C_CARDORIG.DSCARDAPIO,
                            SYSDATE,
                            C_COMENSSERV_QTCOM, C_COMENSSERV_QTCLI, C_COMENSSERV_QTFUN, C_COMENSSERV_QTDOA,                          
                            C_TURNOSERV_QTT1, C_TURNOSERV_QTT2, C_TURNOSERV_QTT3, C_TURNOSERV_QTT4, 'N');
                     ELSE
                        IF V_NRLOGINTCARD IS NULL THEN
                           NOVO_CODIGO('LOGINTCARD'||P_CDFILIDEST, V_NRLOGINTCARD, 1);
                           V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                        
                        END IF;
                        /* 1o Caso: Cardpio seria gravado com comensais = 0 */
                        
                        
                        GRAVA_LOGINTCARD(V_NRLOGINTCARD, P_CDFILIORIG, P_CDFILIDEST, V_CDSERVDEST, V_DTCARDDEST, ' ', ' ', ' ',  '0');
                     END IF;
                  ELSE
                  /* Se j existir cardpio, insere com o nmero antigo */
                     IF V_IDTIPOSERV = 'N' THEN
                        SELECT MAX(NRCARDAPIO), SUM(QTCOMESTICAR)
                        INTO   V_NRCARDAPIO, C_COMENSSERV_QTCOM
                        FROM   CARDADIA
                        WHERE  CDFILIAL   = P_CDFILIDEST AND
                               CDSERVFILI = V_CDSERVDEST AND
                               DTCARDAPIO = V_DTCARDDEST;
                     END IF;
                     IF V_IDTIPOSERV = 'D' THEN
                        SELECT MAX(NRCARDAPIO), SUM(QTCOMESTICAR)
                        INTO   V_NRCARDAPIO, C_COMENSSERV_QTCOM
                        FROM   CARDADIA
                        WHERE  CDFILIAL   = P_CDFILIDEST AND
                               CDSERVFILI = V_CDSERVDEST AND
                               DTCARDAPIO = V_DTCARDDEST AND
                               CDDIETPAD  = V_CDDIETDEST;
                     END IF;
                  END IF; /* V_CONTCARDEST = 0 */

                  IF (C_COMENSSERV_QTCOM <> 0) AND (NOT C_COMENSSERV_QTCOM IS NULL) THEN
                  /* INSERT NA COMPCARD.... */
                     V_NOVOSEQ := V_MAXNRSEQDEST;
                     V_NOVOORD := V_MAXNRORDDEST;
                     FOR C_PRATOSORIG IN
                        (SELECT F.CDFILIAL, C.NRCARDAPIO, F.NRSEQCNFMES NRSEQPRATCAR,
                                C.CDFILAUXPRAT, NVL(C.CDPRATO,'') CDPRATO, C.VRPECONSCARD,
                                F.CDTIPOPRAT, F.NRORDCNFMES NRORDPRATCAR, P.NMPRATO
                         FROM   PRATO P, COMPCARD C, CNFCAMES F, LISTA L
                         WHERE  F.CDFILIAL     = P_CDFILIORIG AND
                                F.CDSERVFILI   = V_CDSERVORIG AND
                                F.DTREFECNFMES = V_DTMESORIG  AND
                                L.NRLISTA      = V_CONFIGORIG AND
                                L.CDLISTA      = LPAD(F.NRSEQCNFMES, 3, '0') AND
                                C.CDFILIAL     (+) = F.CDFILIAL AND
                                C.NRCARDAPIO   (+) = C_CARDORIG.NRCARDAPIO AND
                                C.NRSEQPRATCAR (+) = F.NRSEQCNFMES AND
                                   P.CDPRATO      (+) = C.CDPRATO     AND
                                   P.CDFILAUXPRAT (+) = C.CDFILAUXPRAT
                         ORDER BY NRORDCNFMES)
                     LOOP
                        V_NOVOSEQ := V_NOVOSEQ + 1;
                        V_NOVOORD := V_NOVOORD + 1;

                        IF C_PRATOSORIG.CDPRATO <> '' THEN
                           V_CDFILAUXDEST := C_PRATOSORIG.CDFILAUXPRAT;
                           IF C_PRATOSORIG.CDFILAUXPRAT <> 'P' THEN
                              V_CDFILAUXDEST := P_CDFILIDEST;
                           END IF;

                           /* Verifica se o prato existe na filial destino */
                           V_CONTPRAT  := 1;
                           V_EXISTPRAT := 1;
                           IF P_CDFILIDEST <> P_CDFILIORIG THEN
                              V_EXISTPRAT := 0;
                              SELECT COUNT(*)
                              INTO   V_EXISTPRAT                              
                              FROM   PRATO
                              WHERE  CDFILAUXPRAT = V_CDFILAUXDEST  AND
                                     CDPRATO = C_PRATOSORIG.CDPRATO;

                              V_CONTPRAT := 0;
                              SELECT COUNT(*)
                              INTO   V_CONTPRAT
                              FROM   PRATO
                              WHERE  CDFILAUXPRAT = V_CDFILAUXDEST  AND
                                     CDPRATO = C_PRATOSORIG.CDPRATO AND
                                     TRANSLATE(UPPER(NMPRATO), '', 'AEIOUAEIOUAEIOUAEIOUAONC') =
                                     TRANSLATE(UPPER(C_PRATOSORIG.NMPRATO), '', 'AEIOUAEIOUAEIOUAEIOUAONC');
                           END IF;

                           SELECT MAX(IDUTRPADCA)
                           INTO   V_IDUTRPADCA
                           FROM   PARAMGERAL
                           WHERE  CDPARGERAL = '0001';

                           /* IDUTRPADCA = 'N' --> NO PERMITE RECEITA PADRO NO CARDPIO */
                           V_CONTPRODRECE := 0;
                           IF V_IDUTRPADCA = 'N' THEN
                              SELECT SUM(NUM)
                              INTO V_CONTPRODRECE
                              FROM  (SELECT COUNT(*) NUM
                                     FROM   RECEFILI
                                     WHERE  CDFILAUXPRAT = V_CDFILAUXDEST  AND
                                            CDPRATO = C_PRATOSORIG.CDPRATO AND
                                            CDFILIAL = P_CDFILIDEST
                                     UNION ALL
                                     SELECT COUNT(*) NUM
                                     FROM   RECESERV
                                     WHERE  CDFILAUXPRAT = V_CDFILAUXDEST  AND
                                            CDPRATO = C_PRATOSORIG.CDPRATO AND
                                            CDFILIAL = P_CDFILIDEST AND
                                            CDSERVFILI = V_CDSERVDEST);
                           ELSE
                              SELECT SUM(NUM)
                              INTO V_CONTPRODRECE
                              FROM (SELECT COUNT(*) NUM
                                    FROM   RECEPADR
                                    WHERE  CDFILAUXPRAT = V_CDFILAUXDEST AND
                                           CDPRATO = C_PRATOSORIG.CDPRATO
                                    UNION ALL
                                    SELECT COUNT(*) NUM
                                    FROM   RECEFILI
                                    WHERE  CDFILAUXPRAT = V_CDFILAUXDEST AND
                                           CDPRATO = C_PRATOSORIG.CDPRATO AND
                                           CDFILIAL = P_CDFILIDEST
                                    UNION ALL
                                    SELECT COUNT(*) NUM
                                    FROM   RECESERV
                                    WHERE  CDFILAUXPRAT = V_CDFILAUXDEST AND
                                           CDPRATO = C_PRATOSORIG.CDPRATO AND
                                           CDFILIAL = P_CDFILIDEST AND
                                           CDSERVFILI = V_CDSERVDEST);
                           END IF;

                           /* VERIFICAR SE H PRODUTO INATIVO NO PRATO */
                           /* verificar a receita utilizada pelo prato destino */
                           V_TIPORECE := 'N';
                           SELECT NVL(MAX(TIPO), 'N')
                           INTO   V_TIPORECE
                           FROM  (SELECT 'S' AS TIPO
                                  FROM   RECESERV
                                  WHERE  (CDFILIAL     = P_CDFILIDEST)         AND
                                         (CDSERVFILI   = V_CDSERVDEST)         AND
                                         (CDPRATO      = C_PRATOSORIG.CDPRATO) AND
                                         (CDFILAUXPRAT = V_CDFILAUXDEST)
                                  UNION ALL
                                  SELECT 'F' AS TIPO
                                  FROM   RECEFILI F
                                  WHERE  (CDFILIAL     = P_CDFILIDEST)         AND
                                         (CDPRATO      = C_PRATOSORIG.CDPRATO) AND
                                         (CDFILAUXPRAT = V_CDFILAUXDEST)       AND
                                         NOT EXISTS (SELECT CDPRATO
                                                     FROM   RECESERV
                                                     WHERE  (CDFILIAL     = F.CDFILIAL)     AND
                                                            (CDSERVFILI   = V_CDSERVDEST)   AND
                                                            (CDPRATO      = F.CDPRATO)      AND
                                                            (CDFILAUXPRAT = F.CDFILAUXPRAT))
                                  UNION ALL
                                  SELECT 'P' AS TIPO
                                  FROM   RECEPADR P
                                  WHERE  (CDPRATO      = C_PRATOSORIG.CDPRATO) AND
                                         (CDFILAUXPRAT = V_CDFILAUXDEST)       AND
                                         NOT EXISTS (SELECT CDPRATO
                                                     FROM   RECEFILI
                                                     WHERE  (CDFILIAL     = P_CDFILIDEST)    AND
                                                            (CDPRATO      = P.CDPRATO)       AND
                                                            (CDFILAUXPRAT = P.CDFILAUXPRAT)) AND
                                         NOT EXISTS (SELECT CDPRATO
                                                     FROM   RECESERV
                                                     WHERE  (CDFILIAL     = P_CDFILIDEST) AND
                                                            (CDSERVFILI   = V_CDSERVDEST) AND
                                                            (CDPRATO      = P.CDPRATO)           AND
                                                            (CDFILAUXPRAT = P.CDFILAUXPRAT))) A;
                           /************************/
                           /*Parametro para selecionar apenas produto de nvel completo*/
                           SELECT MAX(CDNVPRODUTO)
                           INTO V_CDNVPRODUTO
                           FROM PRODUTO;
                              
                           V_PRODINATIVO   := FALSE;
                           V_CDARVPRODINAT :='';

                           IF (V_TIPORECE = 'S') THEN  /*RECEITA POR SERVIO COM PRODUTO INATIVO*/
                              FOR C_RECESERV IN (
                                 SELECT  P.CDARVPROD, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                 FROM   PRODUTO P, PRODFILI PF, RECESERV RS
                                 WHERE  PF.CDPRODUTO(+) = P.CDPRODUTO            AND
                                        PF.CDFILIAL (+) = P_CDFILIDEST           AND
                                        P.CDNVPRODUTO   = V_CDNVPRODUTO          AND
                                        RS.CDFILIAL     = P_CDFILIDEST           AND
                                        RS.CDSERVFILI   = V_CDSERVDEST           AND
                                        RS.CDPRATO      = C_PRATOSORIG.CDPRATO   AND
                                        RS.CDFILAUXPRAT = V_CDFILAUXDEST         AND
                                        P.CDPRODUTO     = RS.CDPRODUTO)
                              LOOP
                                IF (C_RECESERV.IDPRODATIV = 'I') OR (C_RECESERV.IDPRODATIVPR = 'N') THEN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                   V_PRODINATIVO := TRUE;
                                   V_CDARVPRODINAT := C_RECESERV.CDARVPROD;
                                END IF;
                              END LOOP;

                           ELSE
                             IF (V_TIPORECE = 'F') THEN  /*RECEITA LOCAL COM PRODUTO INATIVO*/

                                FOR C_RECEFILI IN (
                                    SELECT P.CDARVPROD, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                    FROM   PRODUTO P, PRODFILI PF, RECEFILI RF
                                    WHERE  PF.CDPRODUTO(+) = P.CDPRODUTO          AND
                                           PF.CDFILIAL (+) = P_CDFILIDEST         AND
                                           P.CDNVPRODUTO   = V_CDNVPRODUTO        AND
                                           RF.CDFILIAL     = P_CDFILIDEST         AND
                                           RF.CDPRATO      = C_PRATOSORIG.CDPRATO AND
                                           RF.CDFILAUXPRAT = V_CDFILAUXDEST       AND
                                           P.CDPRODUTO     = RF.CDPRODUTO)
                                LOOP
                                  IF (C_RECEFILI.IDPRODATIV = 'I') OR (C_RECEFILI.IDPRODATIVPR = 'N') THEN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                     V_PRODINATIVO := TRUE;
                                     V_CDARVPRODINAT := C_RECEFILI.CDARVPROD;
                                  END IF;
                                END LOOP;

                             ELSE
                               IF (V_TIPORECE ='P') THEN   /*RECEITA PADRO COM PRODUTO INATIVO*/

                                     FOR C_RECEPADR IN (
                                       SELECT P.CDARVPROD, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                       FROM   PRODUTO  P, PRODFILI PF, RECEPADR RP
                                       WHERE  P.CDNVPRODUTO        = V_CDNVPRODUTO        AND
                                              P_CDFILIDEST         = PF.CDFILIAL(+)       AND
                                              P.CDPRODUTO          = PF.CDPRODUTO(+)      AND
                                              RP.CDPRATO           = C_PRATOSORIG.CDPRATO AND
                                              RP.CDFILAUXPRAT      = V_CDFILAUXDEST       AND
                                              RP.CDPRODUTO         = P.CDPRODUTO)
                                     LOOP
                                       IF (C_RECEPADR.IDPRODATIV = 'I') OR (C_RECEPADR.IDPRODATIVPR = 'N') THEN /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                          V_PRODINATIVO   := TRUE;
                                          V_CDARVPRODINAT := C_RECEPADR.CDARVPROD;
                                       END IF;
                                     END LOOP;

                               END IF; /*RECEITA PADRO COM PRODUTO INATIVO*/
                             END IF;  /*RECEITA LOCAL COM PRODUTO INATIVO geovane*/
                           END IF; /*RECEITA POR SERVIO COM PRODUTO INATIVO geovane*/

                          /***********************/

                           /* FIM - VERIFICAR SE H PRODUTO INATIVO NO PRATO */
                           IF (V_CONTPRAT <> 0) AND (V_CONTPRODRECE <> 0) AND (V_PRODINATIVO <> TRUE)THEN
                              SELECT MAX(A.VALOR / B.QTTPPRATOS)
                              INTO   V_VALOR_A_MAIS
                              FROM   (SELECT C.CDTIPOPRAT, C.NRSEQPRATCAR,
                                             SUM(C.VRPECONSCARD) VALOR
                                      FROM   COMPCARD C
                                      WHERE  C.CDFILIAL   = P_CDFILIORIG AND
                                             C.NRCARDAPIO = C_CARDORIG.NRCARDAPIO AND
                                             NOT EXISTS (SELECT L.CDLISTA
                                                         FROM   LISTA L
                                                         WHERE  L.NRLISTA = V_CONFIGORIG AND
                                                                L.CDLISTA = C.NRSEQPRATCAR)
                                      GROUP BY C.CDTIPOPRAT, C.NRSEQPRATCAR) A,
                                     (SELECT C.CDTIPOPRAT, COUNT(C.CDTIPOPRAT) AS QTTPPRATOS, C.NRSEQCNFMES
                                      FROM   CNFCAMES C, LISTA L
                                      WHERE  C.CDFILIAL     = P_CDFILIORIG AND
                                             C.CDSERVFILI   = V_CDSERVORIG AND
                                             C.DTREFECNFMES = V_DTMESORIG  AND
                                             L.NRLISTA      = V_CONFIGORIG AND
                                             L.CDLISTA      = C.NRSEQCNFMES
                                      GROUP BY C.CDTIPOPRAT, C.NRSEQCNFMES) B
                              WHERE   A.CDTIPOPRAT = B.CDTIPOPRAT AND
                                      A.NRSEQPRATCAR = C_PRATOSORIG.NRSEQPRATCAR;

                              IF V_VALOR_A_MAIS IS NULL THEN
                                 V_VALOR_A_MAIS := 0;
                              END IF;

                              /*Verifica se existia um prato REPROVADO ou ESPECFICO neste sequencial
                                a ser includo*/

                              IF (P_IDSOBREPOR = 'N') THEN
                                 BEGIN
                                    SELECT 'S'
                                      INTO V_UPDATA
                                      FROM COMPCARD
                                     WHERE NRCARDAPIO = V_NRCARDAPIO 
                                       AND CDFILIAL = P_CDFILIDEST
                                       AND NRSEQPRATCAR = C_PRATOSORIG.NRSEQPRATCAR;                                       
                                 EXCEPTION
                                      WHEN NO_DATA_FOUND THEN
                                         V_UPDATA := 'N';
                                 END;                                                                       
                              END IF;   
          
                              IF (P_IDSOBREPOR = 'S') OR (V_UPDATA = 'N') THEN                                                                          
                                 INSERT INTO COMPCARD (CDFILIAL, NRCARDAPIO, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO,
                                                       VRPECONSCARD, CDTIPOPRAT, NRORDPRATCAR, IDPRATOESPE)
                                 VALUES (P_CDFILIDEST, V_NRCARDAPIO, C_PRATOSORIG.NRSEQPRATCAR, V_CDFILAUXDEST, C_PRATOSORIG.CDPRATO,
                                         C_PRATOSORIG.VRPECONSCARD + V_VALOR_A_MAIS, C_PRATOSORIG.CDTIPOPRAT, C_PRATOSORIG.NRORDPRATCAR, 'N');                               
                              END IF;                            
                           ELSE
                           /* LOG DE RESTRIES DA EXPORTAO */
                              IF V_NRLOGINTCARD IS NULL THEN
                                 NOVO_CODIGO('LOGINTCARD'||P_CDFILIDEST, V_NRLOGINTCARD, 1);
                                 V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                              END IF;
                              /* 1o Caso: Prato no existe no destino */
                              IF V_EXISTPRAT = 0 THEN
                                 GRAVA_LOGINTCARD(V_NRLOGINTCARD, P_CDFILIORIG, P_CDFILIDEST, V_CDSERVDEST, V_DTCARDDEST, C_PRATOSORIG.CDPRATO, C_PRATOSORIG.CDFILAUXPRAT, V_CDFILAUXDEST, '1');
                              ELSIF
                              /* 2o Caso: Prato com nome diferente no destino */
                              V_CONTPRAT = 0 THEN
                                 GRAVA_LOGINTCARD(V_NRLOGINTCARD, P_CDFILIORIG, P_CDFILIDEST, V_CDSERVDEST, V_DTCARDDEST, C_PRATOSORIG.CDPRATO, C_PRATOSORIG.CDFILAUXPRAT, V_CDFILAUXDEST, '2');
                              ELSIF
                              /* 3o Caso: Prato no destino mudaria para status padro ou sem receita */
                              V_CONTPRODRECE = 0 THEN
                                 GRAVA_LOGINTCARD(V_NRLOGINTCARD, P_CDFILIORIG, P_CDFILIDEST, V_CDSERVDEST, V_DTCARDDEST, C_PRATOSORIG.CDPRATO, C_PRATOSORIG.CDFILAUXPRAT, V_CDFILAUXDEST, '3');
                              ELSIF
                              /* 4o Caso: Prato no destino contem produto inativo */
                              V_PRODINATIVO = TRUE THEN
                                 GRAVA_LOGINTCARD(V_NRLOGINTCARD, P_CDFILIORIG, P_CDFILIDEST, V_CDSERVDEST, V_DTCARDDEST, C_PRATOSORIG.CDPRATO, C_PRATOSORIG.CDFILAUXPRAT, NULL, NULL);
                              END IF;
                           END IF;
                        END IF;
                     END LOOP; /* C_PRATOSORIG */
                  ELSE
                     IF V_NRLOGINTCARD IS NULL THEN
                        NOVO_CODIGO('LOGINTCARD'||P_CDFILIDEST, V_NRLOGINTCARD, 1);
                        V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                     END IF;
                     /* 1o Caso: Cardpio seria gravado com comensais = 0 */
                     GRAVA_LOGINTCARD(V_NRLOGINTCARD, P_CDFILIORIG, P_CDFILIDEST, V_CDSERVDEST, V_DTCARDDEST, ' ', ' ', ' ', '0');
                  END IF;
               END IF;
            END LOOP; /* C_CARDORIG */
         END IF; /* V_DTCARDDEST */
         V_DTCARDDEST := V_DTCARDDEST + 1;
      END LOOP; /* C_DATAS */
      CLOSE C_DATAS;
      
      COMMIT;
      P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');

      V_LCDSERVORIG := SUBSTR(V_LCDSERVORIG, LENGTH(V_CDSERVORIG)+1, LENGTH(V_LCDSERVORIG));
      V_LCDSERVDEST := SUBSTR(V_LCDSERVDEST, LENGTH(V_CDSERVDEST)+1, LENGTH(V_LCDSERVDEST));
      V_LCONFIGORIG := SUBSTR(V_LCONFIGORIG, LENGTH(V_CONFIGORIG)+1, LENGTH(V_LCONFIGORIG));

      IF SUBSTR(V_LCDSERVORIG, 1, 1) = '_' THEN
         V_LCDSERVORIG := SUBSTR(V_LCDSERVORIG, 2, LENGTH(V_LCDSERVORIG));
      END IF;

      IF SUBSTR(V_LCDSERVDEST, 1, 1) = '_' THEN
         V_LCDSERVDEST := SUBSTR(V_LCDSERVDEST, 2, LENGTH(V_LCDSERVDEST));
      END IF;

      IF SUBSTR(V_LCONFIGORIG, 1, 1) = '_' THEN
         V_LCONFIGORIG := SUBSTR(V_LCONFIGORIG, 2, LENGTH(V_LCONFIGORIG));
      END IF;
   END LOOP; /* Loop para Exportar mais de um Servico */
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_CARDAPIO_INCOR','5.05.016'); END;
/

