/*
Tecnisa - Tecnologia em Informtica

Nome: RESERVAPED

Criao:
09/09/2003 - Raphael Freitas Pinheiro
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'RESERVAPED'
             AND TYPE   = 'V'
             AND U.UID  = O.UID
             AND U.NAME = USER)

   DROP VIEW RESERVAPED
GO
CREATE VIEW RESERVAPED AS
SELECT
   ISNULL(PO.CDFILIAL, RE.CDFILIAL) CDFILIAL, ISNULL(PO.CDPRODUTO, RE.CDPRODUTO) CDPRODUTO,
   ISNULL(PO.CDALMOXARIFE, RE.CDALMOXARIFE) CDALMOXARIFE, ISNULL(PO.CDLOCALESTOQ, RE.CDLOCALESTOQ) CDLOCALESTOQ,
   ISNULL(PO.NRLOTEESTQ, RE.NRLOTEESTQ) NRLOTEESTQ, ISNULL(PO.NRSUBLOTE, RE.NRSUBLOTE) NRSUBLOTE,
   PO.QTTOTALESTOQ, RE.QTRESPRODPED, ISNULL(PO.QTTOTALESTOQ, 0) - ISNULL(RE.QTRESPRODARR,0) QTDISPONIVEL
FROM
   PARAMFILIAL PF,
   POSESTATU PO LEFT JOIN (SELECT CDFILIAL,   CDPRODUTO , CDALMOXARIFE, CDLOCALESTOQ,
                                  NRLOTEESTQ, NRSUBLOTE, SUM(QTRESPRODARR) QTRESPRODARR,
                                  SUM(QTRESPRODPED) QTRESPRODPED
                           FROM RESERPRODPED
                           GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE,
                                    CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) RE ON  (PO.CDFILIAL     = RE.CDFILIAL)      AND
                                                                                (PO.CDPRODUTO    = RE.CDPRODUTO)     AND
                                                                                (PO.CDALMOXARIFE = RE.CDALMOXARIFE)  AND
                                                                                (PO.CDLOCALESTOQ = RE.CDLOCALESTOQ)  AND
                                                                                (PO.NRLOTEESTQ   = RE.NRLOTEESTQ)    AND
                                                                                (PO.NRSUBLOTE    = RE.NRSUBLOTE)
WHERE PO.CDALMOXARIFE = CASE PF.IDUTILALMOX  WHEN 'S' THEN PO.CDALMOXARIFE ELSE ' ' END
  AND PO.CDLOCALESTOQ = CASE PF.IDUTILLCESTQ WHEN 'S' THEN PO.CDLOCALESTOQ ELSE ' ' END
  AND PO.NRLOTEESTQ   = CASE PF.IDUTILLOTE   WHEN 'S' THEN PO.NRLOTEESTQ   ELSE ' ' END
  AND PF.CDFILIAL     = PO.CDFILIAL
GO

-- VERSAO --
EXEC ATUVEROBJ 'RESERVAPED','4.05.126';
GO

